//	-----------------------------------------------------
//
//		Skin:	miniPlayer
//		File:	attribs.m
//		Author:	Aleksandar Ruzicic a.k.a. krckoorascic
//
//		Defines ConfigAttributes used in this skin
//
//				http://www.skinconsortium.com
//	-----------------------------------------------------

#ifndef included
#error This script can only be compiled as a #include
#endif

#ifndef __ATTRIBS_M
#define __ATTRIBS_M

#include <lib/config.mi>

#define OPTIONS_MENU "{1828D28F-78DD-4647-8532-EBA504B8FC04}"
#define HIDDEN_PAGE "{88D371B6-B80C-41FC-9BB1-16DB15BB49FD}"
#define CUSTOM_PAGE "{7B3D2443-71B0-4C68-9408-9159B2B72562}"
#define CUSTOM_PAGE_NOTIFIER "{16DE5E9A-EDDA-48C7-94CA-99EB1CA34B84}"


// --------------------------------------------------------------------
#define CAPTION "miniPlayer"
// skin options menu:
#define NOTIFIER_CAPTION           "Nortifications"
// ------------------------------- (separator)
#define DESKTOP_ALPHA              "Enable desktop alpha"
#define WINDOW_DOCKING             "Enable window docking"
#define ALWAYS_ON_TOP              "Always on top"
#define TOOLTIPS                   "Enable tooltips"
// --------------------------------------------------------------------



// --------------------------------------------------------------------
// notifier submenu:
#define NOTIFIER_SHOW_ALWAYS       "Show Always"
#define NOTIFIER_SHOW_INACTIVE     "Show when inactive/minimized"
#define NOTIFIER_SHOW_MINIMIZED    "Show only when minimized"
#define NOTIFIER_SHOW_NEVER        "Never show (disable)"
// ------------------------------- (separator)
#define NOTIFIER_NO_FULL           "Disable in fullscreen"
// ------------------------------- (separator)
#define NOTIFIER_ANIM_FADE         "Fade in/out"
#define NOTIFIER_ANIM_SLIDE_V      "Slide Vertically"
#define NOTIFIER_ANIM_SLIDE_H      "Slide Horisontally"
#define NOTIFIER_ANIM_NONE         "No Animation"
// ------------------------------- (separator)
#define NOTIFIER_POS_LEFT          "Appears on Left"
#define NOTIFIER_POS_RIGHT         "Appears on Right"
// ------------------------------- (separator)
#define NOTIFIER_POS_TOP           "Appears on Top"
#define NOTIFIER_POS_BOTTOM        "Appears on Bottom"
// --------------------------------------------------------------------


#define NOTIFIER_TIME_IN   "Notifications fade in time"
#define NOTIFIER_TIME_OUT  "Notifications fade out time"
#define NOTIFIER_TIME_HOLD "Notifications display time"


// ------------------------------------------------------------------------- //
// ------------------------------------------------------------------------- //
// ------------------------------------------------------------------------- //
// ------------------------------------------------------------------------- //


Function initAttribs();

Global ConfigAttribute attNotifierAlways, attNotifierMinimized, attNotifierNever;
Global ConfigAttribute attNotifierInactive, attNotifierFullscreen, attNotifierLeft;
Global ConfigAttribute attNotifierRight, attNotifierTop, attNotifierBottom, attNotifierFade;
Global ConfigAttribute attNotifierSlideH, attNotifierSlideV, attNotifierNoAnim;
Global ConfigAttribute attNotifierTimeIn, attNotifierTimeOut, attNotifierTimeHold;
Global ConfigAttribute attDesktopAlpha, sys_attDesktopAlpha, attDocking, sys_attDocking;
Global ConfigAttribute attAlwaysOnTop, sys_attAlwaysOnTop, attTooltips, sys_attTooltips;

#ifndef ON
#define ON "1"
#endif

#ifndef OFF
#define OFF "0"
#endif

initAttribs()
{
	ConfigItem custom_page = Config.newItem(CAPTION, CUSTOM_PAGE);
	ConfigItem custom_page_notifier = Config.newItem(NOTIFIER_CAPTION, CUSTOM_PAGE_NOTIFIER);

	ConfigItem custom_page_nonexposed = Config.newItem("Hidden", HIDDEN_PAGE);

	ConfigItem custom_options_page = Config.getItem(OPTIONS_MENU);

	ConfigAttribute attsubmenu = custom_options_page.newAttribute(CAPTION, "");
	attsubmenu.setData(CUSTOM_PAGE);

	attsubmenu = custom_page.newAttribute(NOTIFIER_CAPTION, "");
	attsubmenu.setData(CUSTOM_PAGE_NOTIFIER);

	attNotifierAlways = custom_page_notifier.newAttribute(NOTIFIER_SHOW_ALWAYS, OFF);
	attNotifierInactive = custom_page_notifier.newAttribute(NOTIFIER_SHOW_INACTIVE, OFF);
	attNotifierMinimized = custom_page_notifier.newAttribute(NOTIFIER_SHOW_MINIMIZED, OFF);
	attNotifierNever = custom_page_notifier.newAttribute(NOTIFIER_SHOW_NEVER, ON);

	ConfigAttribute sep = custom_page_notifier.newAttribute("sep1", ""); sep.setData("-");

	attNotifierFullscreen = custom_page_notifier.newAttribute(NOTIFIER_NO_FULL, ON);

	sep = custom_page_notifier.newAttribute("sep2", ""); sep.setData("-");
	
	attNotifierFade = custom_page_notifier.newAttribute(NOTIFIER_ANIM_FADE, ON);
	attNotifierSlideV = custom_page_notifier.newAttribute(NOTIFIER_ANIM_SLIDE_V, OFF);
	attNotifierSlideH = custom_page_notifier.newAttribute(NOTIFIER_ANIM_SLIDE_H, OFF);
	attNotifierNoAnim = custom_page_notifier.newAttribute(NOTIFIER_ANIM_NONE, OFF);
	
	sep = custom_page_notifier.newAttribute("sep3", ""); sep.setData("-");
	
	attNotifierLeft = custom_page_notifier.newAttribute(NOTIFIER_POS_LEFT, OFF);
	attNotifierRight = custom_page_notifier.newAttribute(NOTIFIER_POS_RIGHT, ON);
	
	sep = custom_page_notifier.newAttribute("sep4", ""); sep.setData("-");
	
	attNotifierTop = custom_page_notifier.newAttribute(NOTIFIER_POS_TOP, OFF);
	attNotifierBottom = custom_page_notifier.newAttribute(NOTIFIER_POS_BOTTOM, ON);

	sep = custom_page.newAttribute("sep5", ""); sep.setData("-");

	attDesktopAlpha = custom_page.newAttribute(DESKTOP_ALPHA, OFF);
	attDocking = custom_page.newAttribute(WINDOW_DOCKING, OFF);
	attAlwaysOnTop = custom_page.newAttribute(ALWAYS_ON_TOP, OFF);
	attTooltips = custom_page.newAttribute(TOOLTIPS, OFF);

	ConfigItem ciMisc;
	ciMisc = Config.getItem("{9149C445-3C30-4E04-8433-5A518ED0FDDE}");
	if(ciMisc != NULL) sys_attDesktopAlpha = ciMisc.getAttribute("Enable desktop alpha");
	attDesktopAlpha.setData(sys_attDesktopAlpha.getData());

	ciMisc = Config.getItem("Options");
	if(ciMisc != NULL)
	{
		sys_attDocking = ciMisc.getAttribute("Enable docking");
		sys_attAlwaysOnTop = ciMisc.getAttribute("Always on top");
	}
	attDocking.setData(sys_attDocking.getData());
	attAlwaysOnTop.setData(sys_attAlwaysOnTop.getData());

	ciMisc = Config.getItem("Skins and UI Tweaks");
	if(ciMisc != NULL) sys_attTooltips = ciMisc.getAttribute("Enable tooltips");
	attTooltips.setData(sys_attTooltips.getData());


	attNotifierTimeIn = custom_page_nonexposed.newAttribute(NOTIFIER_TIME_IN, "1000");
	attNotifierTimeOut = custom_page_nonexposed.newAttribute(NOTIFIER_TIME_OUT, "3000");
	attNotifierTimeHold = custom_page_nonexposed.newAttribute(NOTIFIER_TIME_HOLD, "2000");
}

Global Boolean myChange;

attDesktopAlpha.onDataChanged()
{
	if(myChange) return;
	myChange = true;
	sys_attDesktopAlpha.setData(attDesktopAlpha.getData());
	myChange = false;
}

sys_attDesktopAlpha.onDataChanged()
{
	if(myChange) return;
	myChange = true;
	attDesktopAlpha.setData(sys_attDesktopAlpha.getData());
	myChange = false;
}

attDocking.onDataChanged()
{
	if(myChange) return;
	myChange = true;
	sys_attDocking.setData(attDocking.getData());
	myChange = false;
}

sys_attDocking.onDataChanged()
{
	if(myChange) return;
	myChange = true;
	attDocking.setData(sys_attDocking.getData());
	myChange = false;
}

attAlwaysOnTop.onDataChanged()
{
	if(myChange) return;
	myChange = true;
	sys_attAlwaysOnTop.setData(attAlwaysOnTop.getData());
	myChange = false;
}

sys_attAlwaysOnTop.onDataChanged()
{
	if(myChange) return;
	myChange = true;
	attAlwaysOnTop.setData(sys_attAlwaysOnTop.getData());
	myChange = false;
}

attTooltips.onDataChanged()
{
	if(myChange) return;
	myChange = true;
	sys_attTooltips.setData(attTooltips.getData());
	myChange = false;
}

sys_attTooltips.onDataChanged()
{
	if(myChange) return;
	myChange = true;
	attTooltips.setData(sys_attTooltips.getData());
	myChange = false;
}

#endif