/********************************************************
	*sections in this script: use find function to go between
	*Generic Stuff
	*Main Player
	*Seek
	*Volume
	*EQ Stuff
	*Main Drawer
	*Stick Drawer
	*MO Drawer
	***************************************************/

#include <lib/std.mi>
#include <lib/pldir.mi>

Function setTempText(String txt);
Function emptyTempText();
Function move_Drawer();
Function updatePos();
Function updatePosConX(int x);
Function updateVolume(int v);
Function update_snap(String ident, String size);
Function pos_rem();

Global Group MainEqGrp, StickEqGrp, mainGrp, stickGrp, MainDrawerGrp, StickDrawerGrp, MODrawerGrp, Skin;
Global Layout main, stick;

Global Text SongTicker, SongTickerStick;
Global Timer tickerTimer, hider, SeekBarUpdateTimer, SwitchTimer;
Global Slider MainBalance, StickBalance, Seeker;
Global Boolean sliding, changed, seeking, BtnPressed, Muted, SwitchPressed, DrawerOut, DrawerMoved, stickEq_status, mo_status;
Global String align;
Global Togglebutton MuteBtn;

Class GuiObject HintObject;
Class ToggleButton HintToggleButton;

Global HintToggleButton MainAuto, StickAuto, MainEQ_toggle, StickEQ_toggle, ToggleXFade, Shuffle, Repeat, MainMl, MainPl, StickMl, StickPl;
Global HintObject MainPresets, StickPresets, MainPlay, MainStop, MainPrevious, MainNext, MainPause , MainEq , Open, MainMin, MainClose;
Global HintObject StickPlay, StickStop, StickPrevious, StickNext, StickPause , StickEq, StickMin, StickClose;
Global Button MainWinShade, StickWinShade, MainWinShadeFakie, StickWinShadeFakie;

Global Button MainDrawerButton, StickDrawerButton;
Global Layer MainDrawer, MainDrawerInfo, MODrawer, MODrawerInfo, seekbar, volumebar, StickDrawerInfo;
Global Int DrawerStatus;  //-1 = closed, 1 = open
Global Int MainStartX, MainStartY, MainEndX, MainEndY, MOStartX, MOStartY, MOEndX, MOEndY, repeatVal, len, newpos, mousePos;
Global Int StickStartH, StickStartX, StickStartY, StickEndH, StickEndX, StickEndY, VolumeLevel, mode, mainX, mainY, stickX, stickY;
Global Float speed;

//#include vis.m

System.onScriptLoaded(){

//vis_onScriptLoad();

//<Generic Stuff>-----------------------------------------------------------
	mainGrp = System.getContainer("main").getLayout("normal");
	stickGrp = System.getContainer("main").getLayout("stick");
	MainEqGrp = mainGrp.findObject("eq.main.group");
	StickEqGrp = stickGrp.findObject("eq.stick.group");

	main = MainGrp;
	stick = StickGrp;

	//(int left, int right, int top, int bottom);
	main.snapAdjust(0,0,0,82);
	stick.snapAdjust(0,0,77,0);

	SongTicker = mainGrp.findObject("Songticker");
	SongTickerStick = stickGrp.findObject("Songticker");

	tickerTimer = new Timer;
	tickerTimer.setDelay(1000);

	stickEq_status=false;
	mo_status=false;

	DrawerStatus = -1;
	SwitchPressed = false;
	SwitchTimer = new Timer;
	SwitchTimer.setDelay(1000);
	mode = 0;
	DrawerOut=false;
	DrawerMoved=false;

	mainX = getPrivateInt("miniPlayer", "mainX", 0);
	mainY = getPrivateInt("miniPlayer", "mainY", 0);
	stickX = getPrivateInt("miniPlayer", "stickX", 0);
	stickY = getPrivateInt("miniPlayer", "stickY", 0);

	mainGrp.resize(mainX, mainY, mainGrp.getWidth(), mainGrp.getHeight());
	stickGrp.resize(stickX, stickY, stickGrp.getWidth(), stickGrp.getHeight());

	mousePos=0;
//</Generic Stuff>----------------------------------------------------------

//<Main Player>-------------------------------------------------------------
	MainPlay = mainGrp.findObject("Play");
  	MainPause = mainGrp.findObject("Pause");
  	MainStop = mainGrp.findObject("Stop");
  	MainNext = mainGrp.findObject("Next");
  	MainPrevious = mainGrp.findObject("Previous");
  	Open = mainGrp.findObject("Eject");
  	Shuffle = mainGrp.findObject("ToggleShuffle");
  	Repeat = mainGrp.findObject("Repeat");
	MainMin = mainGrp.findObject("Min");
	MainClose = mainGrp.findObject("Close");
	MainWinShade = mainGrp.findObject("WinShade");
	MainWinShadeFakie = mainGrp.findObject("WinShadeFakie");

  	MainEq = mainGrp.findObject("drawerButton");
  	MainMl = mainGrp.findObject("Ml");
  	MainPl = mainGrp.findObject("Pl");

	StickPlay = stickGrp.findObject("Play");
  	StickPause = stickGrp.findObject("Pause");
  	StickStop = stickGrp.findObject("Stop");
  	StickNext = stickGrp.findObject("Next");
  	StickPrevious = stickGrp.findObject("Previous");
	StickMin = stickGrp.findObject("Min");
	StickClose = stickGrp.findObject("Close");
	StickWinShade = stickGrp.findObject("WinShade");
	StickWinShadeFakie = stickGrp.findObject("WinShadeFakie");

  	StickEq = stickGrp.findObject("eq");
  	StickMl = stickGrp.findObject("Ml");
  	StickPl = stickGrp.findObject("Pl");

	repeatVal = repeat.getCurCfgVal();
	if (repeatVal == -1){
		repeat.setXmlParam("image", "button.songinfo.repeat-1");
	}//Repeat Track
	else if (repeatVal == 0){
		repeat.setXmlParam("image", "button.songinfo.repeat0");
	}//Repeat Off
	else if (repeatVal == 1){
		repeat.setXmlParam("image", "button.songinfo.repeat1");
	}//Repeat Playlist
//</Main Player>------------------------------------------------------------


//<Seek>--------------------------------------------------------------------
	len = getPlayItemLength();
	newpos = getPosition();

	seeking = false;
	changed = false;

	seekbar = mainGrp.findObject("seekbar");
	Seeker = mainGrp.findObject("ghost_seek");
	
	SeekBarUpdateTimer = new Timer;
	SeekBarUpdateTimer.setDelay(1000);

	if (System.getStatus() != 0){
		updatePos();
		SeekBarUpdateTimer.start();
	}
	else if (System.getStatus() == 0){
		seekbar.setXmlParam("w", "0");
	}
//</Seek>-------------------------------------------------------------------

//<Volume>------------------------------------------------------------------
	Muted = getPrivateInt("miniPlayer", "muted", 0);
	VolumeLevel = getPrivateInt("miniPlayer", "old_volume", 0);

	MuteBtn = mainGrp.findObject("mute");
	MuteBtn.setActivated(Muted);

	if (Muted) {
		System.setVolume(0);
		tickerTimer.start();
		SongTicker.setText("Mute ON");
	}
	BtnPressed = 0;

	volumebar = mainGrp.findObject("volumebar");
	volumebar.setXmlParam("w",integertostring((System.getVolume()/2.36)));
//</Volume>-----------------------------------------------------------------

//<EQ Stuff>----------------------------------------------------------------
	MainBalance= MainEqGrp.findObject("bal");
	StickBalance = StickEqGrp.findObject("bal");

	sliding = false;
	
	StickAuto = StickEqGrp.findObject("Auto");
	StickEQ_toggle = StickEqGrp.findObject("On");
	StickPresets = StickEqGrp.findObject("Presets");

	MainAuto = MainEqGrp.findObject("Auto");
	MainEQ_toggle = MainEqGrp.findObject("On");
	MainPresets = MainEqGrp.findObject("Presets");
	//StickEqGrp.hide();
	//uncommenting this^ line causes the stick eq group to be hidden all the time.
//</EQ Stuff>---------------------------------------------------------------

//<Main Drawer>-------------------------------------------------------------
	MainDrawerGrp = mainGrp.findObject("main.eq.drawer");
	MainDrawerInfo = MainDrawerGrp.findObject("DrawerInfo");
	MainDrawerButton = mainGrp.findObject("drawerButton");

	MainStartX = StringToInteger(MainDrawerGrp.getXMLparam("x"));
	MainStartY = StringToInteger(MainDrawerGrp.getXMLparam("y"));
	MainEndX = StringToInteger(MainDrawerInfo.getXMLparam("x"));
	MainEndY = StringToInteger(MainDrawerInfo.getXMLparam("y"));


	hider = new Timer;
	hider.setDelay(1000);
//</Main Drawer>------------------------------------------------------------

//<Stick Drawer>------------------------------------------------------------
	StickDrawerGrp = stickGrp.findObject("stick.eq.drawer");
	StickDrawerButton = stickGrp.findObject("eq");
	StickDrawerInfo = StickDrawerGrp.findObject("DrawerInfo");

	StickStartY = stringToInteger(StickDrawerGrp.getXmlParam("y"));
	StickStartX = stringToInteger(StickDrawerGrp.getXmlParam("x"));
	StickStartH = stringToInteger(StickDrawerGrp.getXmlParam("h"));
	StickEndY = stringToInteger(StickDrawerInfo.getXmlParam("y"));
	StickEndX = stringToInteger(StickDrawerInfo.getXmlParam("x"));
	StickEndH = stringToInteger(StickDrawerInfo.getXmlParam("h"));

	
//</Stick Drawer>-----------------------------------------------------------

//<MO Drawer>---------------------------------------------------------------
	MODrawerGrp = stickGrp.findObject("stick_drawer");

	MODrawer = MODrawerGrp.findObject("MODrawer");
	MODrawerInfo = MODrawerGrp.findObject("MODrawerInfo");
	
	speed = stringToFloat(MODrawerInfo.getXMLparam("w"));

	//prev = MODrawerGrp.findObject("prev");
	//play = MODrawerGrp.findObject("play");
	//pause = MODrawerGrp.findObject("pause");
	//stop = MODrawerGrp.findObject("stop");
	//next = MODrawerGrp.findObject("next");

	MOStartX = StringToInteger(MODrawerGrp.getXMLparam("x"));
	MOStartY = StringToInteger(MODrawerGrp.getXMLparam("y"));
	MOEndX = StringToInteger(MODrawerInfo.getXMLparam("x"));
	MOEndY = StringToInteger(MODrawerInfo.getXMLparam("y"));
//</MO Drawer>--------------------------------------------------------------
}/*************************************************************************/

//<Generic Stuff>-----------------------------------------------------------
System.onScriptUnloading(){
	//vis_onScriptUnload();

	delete tickerTimer;
	delete hider;
	delete SeekBarUpdateTimer;

	setPrivateInt("miniPlayer", "mainX", mainX);
	setPrivateInt("miniPlayer", "mainY", mainY);
	setPrivateInt("miniPlayer", "stickX", stickX);
	setPrivateInt("miniPlayer", "stickY", stickY);
}

setTempText(String txt) {
  	SongTicker.setText(txt);
	SongTickerStick.setText(txt);
}

emptyTempText() {
  	SongTicker.setText("");
	SongTickerStick.setText("");
}

tickerTimer.onTimer(){
	if(changed){
		SongTicker.setXmlParam("align", align);
		changed = false;
	}
	tickerTimer.stop();
	setTempText("");
}
//</Generic Stuff>----------------------------------------------------------

//<Main Player>-------------------------------------------------------------
SongTicker.onLeftButtonDblClk(int x, int y) {
  	PlDir.showCurrentlyPlayingEntry();
}

SongTickerStick.onLeftButtonDblClk(int x, int y) {
  	PlDir.showCurrentlyPlayingEntry();
}

HintObject.onLeftButtonDown(int x, int y) {
  	if ((HintObject == MainPlay)||(HintObject == StickPlay)) setTempText("Play");
  	else if ((HintObject == MainStop)||(HintObject == StickStop)) setTempText("Stop");
  	else if ((HintObject == MainPause)||(HintObject == StickPause)) setTempText("Pause");
  	else if ((HintObject == MainNext)||(HintObject == StickNext)) setTempText("Next");
  	else if ((HintObject == MainPrevious)||(HintObject == StickPrevious)) setTempText("Previous");
  	else if (HintObject == Open) setTempText("Open");
  	else if ((HintObject == MainEq)||(HintObject == StickEq)) setTempText("Equalizer");
	else if ((HintObject == MainMin)||(HintObject == StickMin)) setTempText("Minimize");
	else if ((HintObject == MainClose)||(HintObject == StickClose)) setTempText("Exit");
	else if ((HintObject == MainPresets)||(HintObject == StickPresets)) setTempText("Presets");
	tickerTimer.start();
}

MainWinShadeFakie.onEnterArea(){	
	setTempText("Switch Modes");
	tickerTimer.start();
}

StickWinShadeFakie.onEnterArea(){	
	setTempText("Switch Modes");
	tickerTimer.start();
}

MainWinShadeFakie.onLeftClick(){	
	setTempText("Switch Modes");
	SwitchPressed = true;
	SwitchTimer.setDelay(0);
	if (DrawerOut==true){
		SwitchTimer.setDelay(1000);
		move_Drawer();
		DrawerMoved=true;
	}

	mode = 1;
	SwitchTimer.start();
	tickerTimer.start();
}

StickWinShadeFakie.onLeftClick(){	
	setTempText("Switch Modes");
	SwitchPressed = true;
	SwitchTimer.setDelay(0);
	if (DrawerOut==true){
		SwitchTimer.setDelay(1000);
		move_Drawer();
		DrawerMoved=true;
	}

	mode = -1;
	SwitchTimer.start();
	tickerTimer.start();
}

SwitchTimer.onTimer(){
	SwitchTimer.stop();
	if(SwitchPressed){
		if (mode==1){
			MainWinShade.leftClick();
			mainX = getCurAppLeft();
			mainY = getCurAppTop();
			stickGrp.resize(stickX, stickY, stickGrp.getWidth(), stickGrp.getHeight());
		}
		else if (mode==-1){
			StickWinShade.leftClick();
			stickX = getCurAppLeft();
			stickY = getCurAppTop();
			mainGrp.resize(mainX, mainY, mainGrp.getWidth(), mainGrp.getHeight());
		}
		SwitchPressed = false;
		if (DrawerMoved==true){
			move_Drawer();
			DrawerMoved=false;
		}
	}
}

HintObject.onLeftButtonUp(int x, int y) {
  	emptyTempText();
}

HintObject.onEnterArea(){
  	if ((HintObject == MainPlay)||(HintObject == StickPlay)) setTempText("Play");
  	else if ((HintObject == MainStop)||(HintObject == StickStop)) setTempText("Stop");
  	else if ((HintObject == MainPause)||(HintObject == StickPause)) setTempText("Pause");
  	else if ((HintObject == MainNext)||(HintObject == StickNext)) setTempText("Next");
  	else if ((HintObject == MainPrevious)||(HintObject == StickPrevious)) setTempText("Previous");
  	else if (HintObject == Open) setTempText("Open");
  	else if ((HintObject == MainEq)||(HintObject == StickEq)) setTempText("Equalizer");
	else if ((HintObject == MainMin)||(HintObject == StickMin)) setTempText("Minimize");
	else if ((HintObject == MainClose)||(HintObject == StickClose)) setTempText("Exit");
	else if ((HintObject == MainWinShade)||(HintObject == StickWinShade)) setTempText("Switch Modes");
	else if ((HintObject == MainPresets)||(HintObject == StickPresets)) setTempText("Presets");
	tickerTimer.start();
}

HintObject.onLeaveArea(){
  	emptyTempText();
}

HintToggleButton.onLeftButtonDown(int x, int y){
	if ((HintToggleButton == MainML)||(HintToggleButton == StickML)) setTempText("Media Library");
  	else if ((HintToggleButton == MainPl)||(HintToggleButton == StickPl)) setTempText("Playlist Editor");
	else if (HintToggleButton == Shuffle) setTempText("Shuffle On/Off");
	else if ((HintToggleButton == MainEQ_toggle)||(HintToggleButton == StickEQ_toggle)) setTempText("EQ on/off");
	else if ((HintToggleButton == MainAuto)||(HintToggleButton == StickAuto)) setTempText("Automatic EQ");
}

HintToggleButton.onLeftButtonUp(int x, int y){
  	tickerTimer.start();
}

HintToggleButton.onEnterArea(){
  	if ((HintToggleButton == MainML)||(HintToggleButton == StickML)) setTempText("Media Library");
  	else if ((HintToggleButton == MainPl)||(HintToggleButton == StickPl)) setTempText("Playlist Editor");
	else if (HintToggleButton == Shuffle) setTempText("Shuffle On/Off");
	else if ((HintToggleButton == MainEQ_toggle)||(HintToggleButton == StickEQ_toggle)) setTempText("EQ on/off");
	else if ((HintToggleButton == MainAuto)||(HintToggleButton == StickAuto)) setTempText("Automatic EQ");
	tickerTimer.start();
}

HintToggleButton.onLeaveArea(){
  	if (HintToggleButton != Repeat){
		emptyTempText();
  	}
}

Repeat.onEnterArea(){
	repeatVal = getCurCfgVal();
	if (repeatVal == -1){
		setTempText("Repeat Track");
	}
	else if (repeatVal == 0){
		setTempText("Repeat Off");
	}
	else if (repeatVal == 1){
		setTempText("Repeat Playlist");
	}
}

Repeat.onLeaveArea(){
	emptyTempText();
}

Repeat.onLeftButtonDown(int x, int y){
	repeatVal = getCurCfgVal();
	tickerTimer.start();
	if (repeatVal == 1){
		repeat.setXmlParam("image", "button.songinfo.repeat0");
		repeat.setXmlParam("cfgval", "0");
		setTempText("Repeat Off");
	}
	else if (repeatVal == 0){
		repeat.setXmlParam("image", "button.songinfo.repeat-1");
		repeat.setXmlParam("cfgval", "-1");
		setTempText("Repeat Track");
	}
	else if (repeatVal == -1){
		repeat.setXmlParam("image", "button.songinfo.repeat1");
		repeat.setXmlParam("cfgval", "1");
		setTempText("Repeat Playlist");
	}
}



//</Main Player>------------------------------------------------------------

//<EQ Stuff>----------------------------------------------------------------
System.onEqBandChanged(int band, int newvalue){
	String txt;
	float value;
	
	value=newvalue/10.58;

	txt="Band ";
	if (value>0){
		txt=txt+integerToString(band+1)+": +"+floatToString(value, 1)+" dB";
	}

	if (value<0){
		txt+=integerToString(band+1)+": "+floatToString(value, 1)+" dB";
	}

	else if (value==0){
		txt="Center";
	}

	setTempText(txt);
	tickerTimer.Start();
}

System.onEqPreampChanged(int newvalue){
	String txt;
	float value;
	
	value=newvalue/10.58;
	//a weird bug with the preamp makes me do this
	if (value>11.4) value=12;
	if (floatToString(value, 1)=="-0.2") value=0;

	if (value>0){
		txt="Preamp: +"+floatToString(value, 1)+" dB";
	}

	if (value<0){
		txt="Preamp: "+floatToString(value, 1)+" dB";
	}

	else if (value==0){
		txt="Center";
	}

	setTempText(txt);
	tickerTimer.Start();
}

MainBalance.onSetPosition(int newpos) {
	int pos = newpos-127;
	if (sliding){
		if (pos<0){
			setTempText("Left: "+integerToString((pos*-1)/127*100)+"%");
		}
		else if (pos>0){
			setTempText("Right: "+integerToString(pos/127*100)+"%");
		}
		else if (pos==0){
			setTempText("Center");
		}
		tickerTimer.Start();
	}
}

StickBalance.onSetPosition(int newpos) {
	int pos = newpos-127;
	if (sliding){
		if (pos<0){
			setTempText("Left: "+integerToString((pos*-1)/127*100)+"%");
		}
		else if (pos>0){
			setTempText("Right: "+integerToString(pos/127*100)+"%");
		}
		else if (pos==0){
			setTempText("Center");
		}
		tickerTimer.Start();
	}
}

MainBalance.onLeftButtonDown(int x, int y)
{
	sliding = true;
}

StickBalance.onLeftButtonDown(int x, int y)
{
	sliding = true;
}

MainBalance.onLeftButtonUp(int x, int y)
{
	sliding = false;
}

StickBalance.onLeftButtonUp(int x, int y)
{
	sliding = false;
}
//</EQ Stuff>---------------------------------------------------------------

//<Main And Stick Drawer>---------------------------------------------------
hider.onTimer(){
	hider.stop();
	MainDrawerGrp.hide();
	StickDrawerGrp.hide();
}

MainDrawerButton.onLeftButtonUp(int x, int y) {
	move_Drawer();
}

StickDrawerButton.onLeftButtonUp(int x, int y) {
	move_Drawer();
}

move_Drawer(){
	if (DrawerOut==false) {//Opening
		if (!MainDrawerGrp.isGoingToTarget()) {
			MainDrawerGrp.show();
			update_snap("main_eq", "big");
      		MainDrawerGrp.setTargetX(MainEndX);
      		MainDrawerGrp.setTargetY(MainEndY );
      		MainDrawerGrp.setTargetSpeed(1);
      		MainDrawerGrp.gotoTarget();
      
      		DrawerOut=true;
    		}
		
		if (!StickDrawerGrp.isGoingToTarget()) {
			StickDrawerGrp.show();
			update_snap("stick_eq", "big");
      		StickDrawerGrp.setTargetH(StickEndH);
      		StickDrawerGrp.setTargetY(StickEndY);
			StickDrawerGrp.setTargetX(StickStartX);
      		StickDrawerGrp.setTargetSpeed(1);
      		StickDrawerGrp.gotoTarget();
      
      		DrawerOut=true;
    		}
  	}
  	else  if(DrawerOut=true){//Closing
    		if (!MainDrawerGrp.isGoingToTarget()) {
			update_snap("main_eq", "small");
      		MainDrawerGrp.setTargetX(MainStartX );
      		MainDrawerGrp.setTargetY(MainStartY );
      		MainDrawerGrp.setTargetSpeed(1);
      		MainDrawerGrp.gotoTarget();
      
      		DrawerOut=false;
    		}
	
		if (!StickDrawerGrp.isGoingToTarget()) {
      		StickDrawerGrp.setTargetH(0);
			update_snap("stick_eq", "small");
      		StickDrawerGrp.setTargetY(StickStartY);
			StickDrawerGrp.setTargetX(StickStartX);
      		StickDrawerGrp.setTargetSpeed(1);
      		StickDrawerGrp.gotoTarget();
      
      		DrawerOut=false;
    		}
		hider.start();
  	}
}
//</Main And Stick Drawer>--------------------------------------------------

//<MODrawer>----------------------------------------------------------------

MODrawer.onEnterArea() {
	update_snap("stick_mo", "big");
	MODrawerGrp.setTargetX(MOEndX);
     	MODrawerGrp.setTargetY(MOEndY);
     	MODrawerGrp.setTargetSpeed(speed);
     	MODrawerGrp.gotoTarget();
}

MODrawer.onLeaveArea() {
	update_snap("stick_mo", "small");
     	MODrawerGrp.setTargetX(MOStartX);
     	MODrawerGrp.setTargetY(MOStartY);
     	MODrawerGrp.setTargetSpeed(speed);
     	MODrawerGrp.gotoTarget();
}

StickPrevious.onEnterArea() {
	update_snap("stick_mo", "big");
	MODrawerGrp.setTargetX(MOEndX);
	MODrawerGrp.setTargetY(MOEndY);
	MODrawerGrp.setTargetSpeed(speed);
	MODrawerGrp.gotoTarget();
}

StickPlay.onEnterArea() {
	update_snap("stick_mo", "big");
	MODrawerGrp.setTargetX(MOEndX);
	MODrawerGrp.setTargetY(MOEndY);
	MODrawerGrp.setTargetSpeed(speed);
	MODrawerGrp.gotoTarget();
}

StickPause.onEnterArea() {
	update_snap("stick_mo", "big");
	MODrawerGrp.setTargetX(MOEndX);
	MODrawerGrp.setTargetY(MOEndY);
	MODrawerGrp.setTargetSpeed(speed);
	MODrawerGrp.gotoTarget();
}

StickStop.onEnterArea() {
	update_snap("stick_mo", "big");
	MODrawerGrp.setTargetX(MOEndX);
	MODrawerGrp.setTargetY(MOEndY);
	MODrawerGrp.setTargetSpeed(speed);
	MODrawerGrp.gotoTarget();
}

StickNext.onEnterArea() {
	update_snap("stick_mo", "big");
	MODrawerGrp.setTargetX(MOEndX);
	MODrawerGrp.setTargetY(MOEndY);
	MODrawerGrp.setTargetSpeed(speed);
	MODrawerGrp.gotoTarget();
}
//</MODrawer>---------------------------------------------------------------

//<Seek>--------------------------------------------------------------------
SeekBarUpdateTimer.onTimer()
{
	SeekBarUpdateTimer.Stop();	
	updatePos();
}

System.onSeek(int newpos){
	updatePos();
}

updatePos()
{
	if(!seeking){
		len = getPlayItemLength();
		newpos = getPosition();
		seekbar.setXmlParam("w",integertostring((((newpos/len)*100)*0.86)));
	}
	else seekbar.setXmlParam("w",integertostring(mousePos));

	SeekBarUpdateTimer.start();
}

Seeker.onSetPosition(int newpos) {
	if (seeking){
		//updatePos();	
		Float f;
		f = newpos;
		f = f / 255 * 100;
		Float len = getPlayItemLength();
		if (len != 0) {
			int curPos = len * f / 100;
			tickerTimer.start();
			if (!changed){
				align = SongTicker.getXmlParam("align");
				SongTicker.setXmlParam("align", "center");
				changed = true;
			}
			setTempText(integerToTime(curPos) + "/" + integerToTime(len) + " : " + integerToString(f) + "%");
		}		
	}
}

Seeker.onMouseMove(int x, int y){
	mousePos = x-72;
	if (seeking) updatePos();
}

updatePosConX(int x){
	seekbar.setXmlParam("w",integertostring(x));
}

Seeker.onLeftButtonDown(int x, int y)
{
	seeking = true;
	SeekBarUpdateTimer.stop();
}

Seeker.onLeftButtonUp(int x, int y)
{
	seeking = false;
	if (getStatus()==1) SeekBarUpdateTimer.start();
}

System.onStop(){
	seekbar.setXmlParam("w", "0");
	SeekBarUpdateTimer.Stop();
}

System.onPause(){
	SeekBarUpdateTimer.Stop();
}

System.onPlay(){
	updatePos();
}

System.onResume(){
	updatePos();
}

//</Seek>-------------------------------------------------------------------

//<Volume>------------------------------------------------------------------
MuteBtn.onEnterArea() {
	if (!Muted) {
		setTempText("Mute");
	} else {
		setTempText("Unmute");
	}
	tickerTimer.start();
}

MuteBtn.onLeftClick() {
	BtnPressed = 1;
	if (!Muted) {
		VolumeLevel = System.getVolume();
		System.setVolume(0);
		Muted = 1;
		tickerTimer.start();
		setTempText("Mute ON");
	} else {
		System.setVolume(VolumeLevel);
		Muted = 0;
		tickerTimer.start();
		setTempText("Mute OFF");
	}

}

System.onvolumechanged(int newvol)
{
	volumebar.setXmlParam("w",integertostring( (newvol/2.36)));
	if (!BtnPressed) {
		tickerTimer.start();
		setTempText("Volume:" + System.integerToString(newvol/2.55) + "%");

		if (Muted) {
			MuteBtn.setActivated(0);
			Muted = 0;
		}
	}
	BtnPressed = 0;
}
//</Volume>-----------------------------------------------------------------

//<Window Position>---------------------------------------------------------
update_snap(String ident, String size){
	if (ident == "main_eq"){
		if (size == "big") main.snapAdjust(0,0,0,0);
		else if (size == "small") main.snapAdjust(0,0,0,82);
	}

	if (ident == "stick_eq"){
		if (size == "big"){
			stick.snapAdjust(0,0,0,0);
			stickEq_status=true;
		}
		else if (size == "small"){
			stick.snapAdjust(0,0,77,0);
			stickEq_status=false;
		}
	}
	
	if (ident == "stick_mo"){
		if (size == "big"){
			if (stickEq_status==false) stick.snapAdjust(0,0,77,0);
			if (stickEq_status==true) stick.snapAdjust(0,0,0,0);
			mo_status=true;
		}
		else if (size == "small"){
			if (stickEq_status==false) stick.snapAdjust(0,0,77,0);
			if (stickEq_status==true) stick.snapAdjust(0,0,0,0);
			mo_status=false;
		}
	}
}
//</Window Position>--------------------------------------------------------
/*End Of Script************************************************************/